;
; Vzorec: hromadka - odeber = n_nasobek(maxodeber + 1)
; odeber = hromadka mod (maxodeber + 1)
;

(defun sirky_hraj_pocitac() 
	(write-char #\Newline)
	(write-line "Nyni je na rade pocitac...")
	(format t "V hromadce je ~D sirek.~%" hromadka)
	(setq odeber (mod hromadka (+ pocets 1)))
	(when (EQUAL odeber 0) (setq odeber 1))
	(when (<= hromadka maxodber) (setq odeber hromadka))
	(setq hromadka (- hromadka odeber))
	(format t "Pocitac odebral ~D sirek.~%V hromadce zustalo ~D sirek.~%" odeber hromadka)
)

(defun sirky_hraj_hrac()
	(write-char #\Newline)
	(setq maxodber pocets)
	(when (< hromadka maxodber) (setq maxodber hromadka))
	(write-line "Nyni jsi na rade.")
	
	(format t "V hromadce je ~D sirek.~%Kolik chces odebrat sirek? Muzes odebrat 1 az ~D sirek, 0 sirek pro konec.~%Vase volba: " hromadka maxodber)
	(loop
		(setq odeber (read))
		(cond
			((EQUAL odeber 0) (write-line "Koncime...")(exit))
			((> odeber maxodber) 
				(format t "Spatny pocet sirek, muzes vzit 1 az ~D sirek, 0 pro konec.~%Vase volba: " maxodber)
			)
			(T (return odeber))
		)
	)
	(setq hromadka (- hromadka odeber))
)

(defun sirky_start()
	(write-char #\Newline)
	(write-line "Hra sirky. Nyni je nutne si zvolit pocet sirek v hromadce a kolik se muze maximalne odebrat.")
	(write-string "V hromadce je sirek: ") (setq hromadka (read))
	(when (<= hromadka 0) (write-line "Koncime...")(exit))
	(loop
		(write-string "Maximalne se muze odebrat: ")
		(setq pocets (read))
		(when (<= pocets 0) (write-line "Koncime...")(exit))
		(when (<= pocets hromadka) (return))
		(write-line "Sirek kolik muzeme odebrat musi bytr mensi nebo rovno poctu sirek v hromadce!!!")
	)
	(write-char #\Newline)

	(write-string "Chceta zacinat? 1-ano nebo 2-ne: ")
	(setq x (read))
	(when (EQUAL x 1) (sirky_hraj_hrac))
	
	(loop 
		(when (<= hromadka 0) (setq vyhral 1)(return 1))
		(sirky_hraj_pocitac)
		(when (<= hromadka 0) (setq vyhral 0)(return 0))
		(sirky_hraj_hrac)
	)
	(write-char #\Newline)
	(if (EQUAL vyhral 1) 
		(write-line "Vyhral jsi, gratuluji!!!")
		(write-line "Prohral jsi, snad se ti povede priste vyhrat.")
	)
	(write-string "Chces hrat znovu? 1-ano nebo 2-ne: ")
	(setq x (read))
	(when (EQUAL x 1) (sirky_start))
)


(sirky_start)