%Definice grafu:
hrana(1, 4).
hrana(1, 5).
hrana(2, 1).
hrana(2, 4).
hrana(3, 1).
hrana(3, 2).
hrana(3, 4).
hrana(4, 5).

%Rekurzivn definice, posloupnost prochzench uzl se ukld do seznamu:
cesta(X,Y,[X,Y]) :- hrana(X,Y).
cesta(X,Y,[X|T]) :- hrana(X,Z), cesta(Z,Y,T).

%Pouit prediktu FINDALL (v listeneru) a vpis seznamu s X, pro kter je splnn predikt cesta(2, 5, X):
%?- findall(X, cesta(2, 5, X), LIST_OF_Xs).

%Pouit prediktu FINDALL (v programu) a vpis seznamu s X, pro kter je splnn predikt cesta(2, 5, X):
fa1 :- findall(X, cesta(2, 5, X), LIST_OF_Xs), write(LIST_OF_Xs).

%Jin monost aneb jak "udlat to sam" jinmi prostedky:
fa2 :- cesta(2, 5, X), write(X), nl, fail.
%tohle udela, ze na fa2 vrati misto no, yes. (ciste kosmeticka zalezitost)
fa2.