% Priklad na vysvetleni funkce predikatu "!" (vysvetleno v helpu)
% Program "wumpus.pro" vykuchal a co zbylo veselymi 
% komentari opatril rohlik@kiv.zcu.cz


% Graf - ktera mistnost je spojena s kterou 
connected(1, 4).
connected(1, 5).
connected(2, 1).
connected(2, 4).
connected(3, 1).
connected(3, 2).
connected(3, 4).
connected(4, 5).


% Kolikaty pokus o splneni cile ... pri kazdem neuspechu 
% plneni "connected" se diky "!" snazime najit novou unifikaci 
% promenne X v predikatu "pokus(X)", coz je podcil cile "go". 
pokus(1).
pokus(2).
pokus(3).
pokus(4).
pokus(5).


% Inicializace. Na zacatku programu je Wumpus v mistnosti cislo 2
wumpus(2).


% Sledujeme pokusy a pohyb Wumpuse
go :- pokus(X), write('Pokus cislo '), write(X), 
	nl, movewumpus, nl, 
	write('Skoncil pokus cislo '), write(X).


% Nejprve se X unifikuje s cislem mistnosti, kde prave Wumpus je.
% Pak se hleda mistnost Y, do ktere by bylo mozno Wumpuse presunout. 
% Z databaze se vyjme fakt "wumpus(X)" a naopak se do ni prida 
% fakt "wumpus(Y)".
movewumpus:- wumpus(X), 
	write('Predikat "movewumpus" v akci ... '),nl,
	write('Pred testem CONNECTED je Wumpus v mistnosti '), write(X),nl,
	!,connected(X,Y),retract(wumpus(X)),
	assert(wumpus(Y)),
	write('Po testu CONNECTED je Wumpus v mistnosti '), write(Y).
movewumpus:-write('I do nothing').


% Teprve tady bude videt kouzlo operatoru "!" -> po ctvrtem
% prikazu "go." se neunifikuje s X v predikatu wumpus(X), 
% ale v predikatu pokus(X) tedy "o uroven vyse". Je to 
% videt napriklad z toho, ze se podruhe nevypisuje hlaska 
% 'Predikat "movewumpus" v akci ... '
%
% Pro stale tapajici: Zkuste odstranit vykricnik z pravidla
% "movewumpus" a uvidite.

% pridame "wumpus(8).", aby byl videt dalsi pokus o unifikaci v movewumpus.
%wumpus(8).